=== debian/changelog ===
nsnake (1.5-1) unstable; urgency=low

  * Initial release (Closes: #706048)

 -- Alexandre Dantas <alex.dantas92@gmail.com>  Tue, 23 Apr 2013 17:14:42 -0300
