=== debian/control ===
Source: nsnake
Section: games
Priority: optional
Maintainer: Alexandre Dantas <alex.dantas92@gmail.com>
Build-Depends: debhelper (>= 9), libncurses5-dev
Standards-Version: 3.9.4
Homepage: http://www.alexdantas.net/projects/nsnake/
Vcs-Git: git://github.com/alexdantas/nSnake.git
Vcs-Browser: https://github.com/alexdantas/nSnake

Package: nsnake
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: classic snake game with textual interface
 nsnake is an implementation of the classic snake game with textual
 interface. It is playable at command-line with ncurses-like graphics.
 .
 Features high-scores and two game modes - with and without borders.
 .
 Screenshot: http://alexdantas.net/nsnake-screenshot.png
