=== debian/watch ===
version=3
http://sf.net/nsnake/nsnake-(.+)\.tar\.gz
