=== debian/changelog ===
nsnake (3.0.1-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop "Rules-Requires-Root: no": it is the default now
  * Bump Standards-Version to 4.7.3, drop Priority: tag
  * Rewrite d/watch in v5 format
  * Add debian/salsa-ci.yml
  * Drop old Debian menu entry, there is a .desktop file

  [ Helmut Grohne ]
  * fix FTCBFS: links with the build architecture compiler during make install
    (Closes: #1098409)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 21 Jan 2026 08:13:56 +0100

nsnake (3.0.1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Import game on Salsa
  * Switch to DebHelper 13
  * Make the build verbose (Closes: #923122)
  * Set Rules-Requires-Root: no
  * Build-depends-on-obsolete-package libncurses5-dev

 -- Alexandre Detiste <tchet@debian.org>  Mon, 09 Dec 2024 19:58:39 +0100

nsnake (3.0.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Chris Lamb ]
  * Make the build reproducible. (Closes: #833612)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 17 Nov 2022 17:49:38 +0000

nsnake (3.0.1-2) unstable; urgency=medium

  * Updated maintainer mail address
  * Cryptographic signature verification: upstream provides
    a PGP signature to verify the tarball. Consequently:
    - Added debian/upstream/signing-key.asc
    - Updated debian/watch
  * Removed desktop file and PNG/XPM icons because they're
    already provided by upstream

 -- Alexandre Dantas <eu@alexdantas.net>  Mon, 11 Aug 2014 15:48:05 -0400

nsnake (3.0.1-1) unstable; urgency=low

  * New upstream version.

 -- Alexandre Dantas <eu@alexdantas.net>  Thu, 31 Jul 2014 00:37:58 -0400

nsnake (1.5-2) unstable; urgency=low

  * Bumped standards version to 3.9.5
  * Added desktop and menu files, plus icons (Closes: #737978)
  * Fixed end-of-line error on hardening patch file (Closes: #753241)
  * Updated VCS links on debian/control

 -- Alexandre Dantas <eu@alexdantas.net>  Wed, 09 Jul 2014 23:30:23 -0400
