=== debian/control ===
Source: nsnake
Section: games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Alexandre Dantas <eu@alexdantas.net>,
Build-Depends: debhelper-compat (= 13), libncurses-dev
Standards-Version: 4.7.3
Homepage: http://nsnake.alexdantas.net/
Vcs-Git: https://salsa.debian.org/games-team/nsnake.git
Vcs-Browser: https://salsa.debian.org/games-team/nsnake

Package: nsnake
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: classic snake game on the terminal
 nsnake is a clone of the snake game found on old cellphones. It is
 played on the command-line with textual interface, thanks to ncurses.
 .
 Features high-scores, several game modes, a GUI-like interface and
 custom levels.
