=== debian/watch ===
Version: 5

Source: http://sf.net/nsnake/
Matching-Pattern: nsnake-(.+)\.tar\.gz
Pgpsigurlmangle: s/.*nsnake-(\d\S*)\.tar\.gz/http:\/\/alexdantas.net\/projects\/nsnake\/meta\/nsnake-$1\.tar\.gz\.asc/
